<html>
<head>
<title>OgreInstanceManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreInstanceManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreInstanceManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __InstanceManager_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __InstanceManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMesh_8h.html">OgreMesh.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00062"></a><a class="code" href="classOgre_1_1InstanceManager.html">00062</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">FactoryAlloc</a>
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00065"></a><a class="code" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">00065</a>         <span class="keyword">enum</span> <a class="code" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">InstancingTechnique</a>
<a name="l00066"></a>00066         {
<a name="l00067"></a><a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622adfd14a6d905e8f639010dceb63fd6a99">00067</a>             <a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622adfd14a6d905e8f639010dceb63fd6a99">ShaderBased</a>,            <span class="comment">//Any SM 2.0+ @See InstanceBatchShader</span>
<a name="l00068"></a><a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622aa936e137d1695cec1b763a270dc73a3e">00068</a>             <a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622aa936e137d1695cec1b763a270dc73a3e">TextureVTF</a>,             <span class="comment">//Needs Vertex Texture Fetch &amp; SM 3.0+ @See InstanceBatchVTF</span>
<a name="l00069"></a><a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622a20f1ebda9178d5f5f4ebe613f3432eac">00069</a>             <a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622a20f1ebda9178d5f5f4ebe613f3432eac">HWInstancingBasic</a>,      <span class="comment">//Needs SM 3.0+ and HW instancing support @See InstanceBatchHW</span>
<a name="l00070"></a><a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622ac1ad45db6c7bc954c0374c37c8ed1b0d">00070</a>             <a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622ac1ad45db6c7bc954c0374c37c8ed1b0d">HWInstancingVTF</a>,        <span class="comment">//Needs SM 3.0+, HW instancing support &amp; VTF @See InstanceBatchHW_VTF</span>
<a name="l00071"></a><a class="code" href="group__Scene.html#gga98fb2a9ada779b56d48f74040e96a622a3efbc531e529142ddfd5c7272a373ece">00071</a>             InstancingTechniquesCount
<a name="l00072"></a>00072         };
<a name="l00073"></a>00073 
<a name="l00075"></a><a class="code" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508">00075</a>         <span class="keyword">enum</span> <a class="code" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508" title="Values to be used in setSetting() &amp; BatchSettings::setting.">BatchSettingId</a>
<a name="l00076"></a>00076         {
<a name="l00078"></a><a class="code" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a4fa34122dba5df1604cd9cd44ee1c519">00078</a>             CAST_SHADOWS        = 0,
<a name="l00080"></a><a class="code" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a5aa5845eaa01e5c54fc92fc74b2f4176">00080</a>             <a class="code" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a5aa5845eaa01e5c54fc92fc74b2f4176" title="Makes each batch to display it&#39;s bounding box. Useful for debugging or profiling.">SHOW_BOUNDINGBOX</a>,
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="group__Scene.html#gga7832eb9e2627f71382fefc7293482508a93252cb20077bbc127c02d96f5d696f0">00082</a>             NUM_SETTINGS
<a name="l00083"></a>00083         };
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keyword">private</span>:
<a name="l00086"></a><a class="code" href="structOgre_1_1InstanceManager_1_1BatchSettings.html">00086</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1InstanceManager_1_1BatchSettings.html">BatchSettings</a>
<a name="l00087"></a>00087         {
<a name="l00088"></a>00088             <span class="comment">//These are all per material</span>
<a name="l00089"></a><a class="code" href="group__Scene.html#ga2c32100efe26093807424d2032f66464">00089</a>             <span class="keywordtype">bool</span>                setting[NUM_SETTINGS];
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="group__Scene.html#gad9b21aa78c94911add2c52c474d8d48c">00091</a>             <a class="code" href="structOgre_1_1InstanceManager_1_1BatchSettings.html">BatchSettings</a>()
<a name="l00092"></a>00092             {
<a name="l00093"></a>00093                 setting[CAST_SHADOWS]               = <span class="keyword">true</span>;
<a name="l00094"></a>00094                 setting[SHOW_BOUNDINGBOX]           = <span class="keyword">false</span>;
<a name="l00095"></a>00095             }
<a name="l00096"></a>00096         };
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">00098</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;InstanceBatch*&gt;::type</a>        <a class="code" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a>;   <span class="comment">//vec[batchN] = Batch</span>
<a name="l00099"></a><a class="code" href="group__Scene.html#ga2ee4131bd90f78a8f66acb0649e830ee">00099</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, InstanceBatchVec&gt;::type</a> <a class="code" href="group__Scene.html#ga2ee4131bd90f78a8f66acb0649e830ee">InstanceBatchMap</a>;   <span class="comment">//map[materialName] = Vec</span>
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="group__Scene.html#gafb62bc67a8ccd5ce513811585cecffd9">00101</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, BatchSettings&gt;::type</a>    <a class="code" href="group__Scene.html#gafb62bc67a8ccd5ce513811585cecffd9">BatchSettingsMap</a>;
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="group__Scene.html#ga01ab189e423504ec998421dff23f9644">00103</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>            <a class="code" href="group__Scene.html#ga01ab189e423504ec998421dff23f9644">mName</a>;                  <span class="comment">//Not the name of the mesh</span>
<a name="l00104"></a><a class="code" href="group__Scene.html#ga2da3cbab89cc6405d656acc508c3f7c8">00104</a>         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>                 <a class="code" href="group__Scene.html#ga2da3cbab89cc6405d656acc508c3f7c8">mMeshReference</a>;
<a name="l00105"></a><a class="code" href="group__Scene.html#ga9d5879cee81bbc67cdfaf64524bd2169">00105</a>         <a class="code" href="group__Scene.html#ga2ee4131bd90f78a8f66acb0649e830ee">InstanceBatchMap</a>        <a class="code" href="group__Scene.html#ga9d5879cee81bbc67cdfaf64524bd2169">mInstanceBatches</a>;
<a name="l00106"></a><a class="code" href="group__Scene.html#ga7d4ce97e2f3705998d7722f1c92a766e">00106</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga7d4ce97e2f3705998d7722f1c92a766e">mIdCount</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="group__Scene.html#ga40e25e0d974bc9cb8fdafef707618d57">00108</a>         <a class="code" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a>        <a class="code" href="group__Scene.html#ga40e25e0d974bc9cb8fdafef707618d57">mDirtyBatches</a>;
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="group__Scene.html#ga05e37e984cb6aad0278e5201080c6584">00110</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>         <a class="code" href="group__Scene.html#ga05e37e984cb6aad0278e5201080c6584">mSharedRenderOperation</a>;
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="group__Scene.html#ga3b584885553efad689ce7f0b006bb6fe">00112</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga3b584885553efad689ce7f0b006bb6fe">mInstancesPerBatch</a>;
<a name="l00113"></a><a class="code" href="group__Scene.html#gad52ab17fc279b813acca218429a8b9d5">00113</a>         <a class="code" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">InstancingTechnique</a>     <a class="code" href="group__Scene.html#gad52ab17fc279b813acca218429a8b9d5">mInstancingTechnique</a>;
<a name="l00114"></a><a class="code" href="group__Scene.html#ga1d827707f203bd601ecd178717cd9f95">00114</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>                  <a class="code" href="group__Scene.html#ga1d827707f203bd601ecd178717cd9f95">mInstancingFlags</a>;       <span class="comment">//@see InstanceManagerFlags</span>
<a name="l00115"></a><a class="code" href="group__Scene.html#gac2afda10e925bbfe4edd50cf7352b66e">00115</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>          <a class="code" href="group__Scene.html#gac2afda10e925bbfe4edd50cf7352b66e">mSubMeshIdx</a>;
<a name="l00116"></a>00116         
<a name="l00117"></a><a class="code" href="group__Scene.html#ga86b59263bf4bac17d33c4365c65c9e37">00117</a>         <a class="code" href="group__Scene.html#gafb62bc67a8ccd5ce513811585cecffd9">BatchSettingsMap</a>        <a class="code" href="group__Scene.html#ga86b59263bf4bac17d33c4365c65c9e37">mBatchSettings</a>;
<a name="l00118"></a><a class="code" href="group__Scene.html#ga31cedf671001b7363491c9facbf95745">00118</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>*           <a class="code" href="group__Scene.html#ga31cedf671001b7363491c9facbf95745">mSceneManager</a>;
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="group__Scene.html#ga13f71a588460dab9f41c300311af87a6">00120</a>         <span class="keywordtype">size_t</span>                  <a class="code" href="group__Scene.html#ga13f71a588460dab9f41c300311af87a6">mMaxLookupTableInstances</a>;
<a name="l00124"></a>00124         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>* getFreeBatch( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName );
<a name="l00125"></a>00125 
<a name="l00135"></a>00135         <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>* buildNewBatch( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName, <span class="keywordtype">bool</span> firstTime );
<a name="l00136"></a>00136 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> defragmentBatches( <span class="keywordtype">bool</span> optimizeCull, <a class="code" href="structOgre_1_1vector.html">vector&lt;InstancedEntity*&gt;::type</a> &amp;entities,
<a name="l00140"></a>00140                                 <a class="code" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a> &amp;fragmentedBatches );
<a name="l00141"></a>00141 
<a name="l00145"></a>00145         <span class="keywordtype">void</span> applySettingToBatches( <a class="code" href="group__Scene.html#ga7832eb9e2627f71382fefc7293482508" title="Values to be used in setSetting() &amp; BatchSettings::setting.">BatchSettingId</a> <span class="keywordtype">id</span>, <span class="keywordtype">bool</span> value, <span class="keyword">const</span> <a class="code" href="group__Scene.html#ga38c19279985051c8c65d6df62bfb8f86">InstanceBatchVec</a> &amp;container );
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="keyword">public</span>:
<a name="l00148"></a>00148         <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;customName, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *sceneManager,
<a name="l00149"></a>00149                          <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;meshName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;groupName,
<a name="l00150"></a>00150                          <a class="code" href="group__Scene.html#ga98fb2a9ada779b56d48f74040e96a622">InstancingTechnique</a> instancingTechnique, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> instancingFlags,
<a name="l00151"></a>00151                          <span class="keywordtype">size_t</span> instancesPerBatch, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> subMeshIdx, <span class="keywordtype">bool</span> useBoneMatrixLookup = <span class="keyword">false</span>);
<a name="l00152"></a>00152         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a>();
<a name="l00153"></a>00153 
<a name="l00154"></a><a class="code" href="group__Scene.html#gaa0ac29a317cd26fd5b83b18598b081b4">00154</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="group__Scene.html#gaa0ac29a317cd26fd5b83b18598b081b4">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00155"></a>00155 
<a name="l00161"></a>00161         <span class="keywordtype">void</span> setInstancesPerBatch( <span class="keywordtype">size_t</span> instancesPerBatch );
<a name="l00162"></a>00162 
<a name="l00171"></a>00171         <span class="keywordtype">void</span> setMaxLookupTableInstances( <span class="keywordtype">size_t</span> maxLookupTableInstances );
<a name="l00172"></a>00172 
<a name="l00184"></a>00184         <span class="keywordtype">size_t</span> getMaxOrBestNumInstancesPerBatch( <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> materialName, <span class="keywordtype">size_t</span> suggestedSize, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> flags );
<a name="l00185"></a>00185 
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>* createInstancedEntity( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName );
<a name="l00188"></a>00188 
<a name="l00195"></a>00195         <span class="keywordtype">void</span> cleanupEmptyBatches(<span class="keywordtype">void</span>);
<a name="l00196"></a>00196 
<a name="l00220"></a>00220         <span class="keywordtype">void</span> defragmentBatches( <span class="keywordtype">bool</span> optimizeCulling );
<a name="l00221"></a>00221 
<a name="l00237"></a>00237         <span class="keywordtype">void</span> setSetting( BatchSettingId <span class="keywordtype">id</span>, <span class="keywordtype">bool</span> value, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a> );
<a name="l00238"></a>00238 
<a name="l00240"></a>00240         <span class="keywordtype">bool</span> getSetting( BatchSettingId <span class="keywordtype">id</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName ) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00245"></a><a class="code" href="group__Scene.html#ga5fe7226ee5363b1b369d684d15af519f">00245</a>         <span class="keywordtype">bool</span> hasSettings( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName )<span class="keyword"> const</span>
<a name="l00246"></a>00246 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mBatchSettings.find( materialName ) != mBatchSettings.end(); }
<a name="l00247"></a>00247 
<a name="l00249"></a>00249         <span class="keywordtype">void</span> setBatchesAsStaticAndUpdate( <span class="keywordtype">bool</span> bStatic );
<a name="l00250"></a>00250 
<a name="l00254"></a>00254         <span class="keywordtype">void</span> _addDirtyBatch( <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a> *dirtyBatch );
<a name="l00255"></a>00255 
<a name="l00257"></a>00257         <span class="keywordtype">void</span> _updateDirtyBatches(<span class="keywordtype">void</span>);
<a name="l00258"></a>00258 
<a name="l00259"></a><a class="code" href="group__Scene.html#ga449864e9fe068c83c3955dfcc112a2d1">00259</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;InstanceBatchMap&gt;</a> <a class="code" href="group__Scene.html#ga449864e9fe068c83c3955dfcc112a2d1">InstanceBatchMapIterator</a>;
<a name="l00260"></a><a class="code" href="group__Scene.html#ga81a850f3da3dc22baa6d8fbd68a1723f">00260</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;InstanceBatchVec&gt;</a> <a class="code" href="group__Scene.html#ga81a850f3da3dc22baa6d8fbd68a1723f">InstanceBatchIterator</a>;
<a name="l00261"></a>00261 
<a name="l00263"></a><a class="code" href="group__Scene.html#ga865be521d280fc4daed5bbf0484ab65f">00263</a>         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">InstanceBatchMapIterator</a> getInstanceBatchMapIterator(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00264"></a>00264 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">InstanceBatchMapIterator</a>( mInstanceBatches.begin(), mInstanceBatches.end() ); }
<a name="l00265"></a>00265 
<a name="l00272"></a><a class="code" href="group__Scene.html#ga5f829261ff3c96310308825bfc5ebe0b">00272</a>         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">InstanceBatchIterator</a> getInstanceBatchIterator( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;materialName )<span class="keyword"> const</span>
<a name="l00273"></a>00273 <span class="keyword">        </span>{
<a name="l00274"></a>00274             InstanceBatchMap::const_iterator it = mInstanceBatches.find( materialName );
<a name="l00275"></a>00275             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">InstanceBatchIterator</a>( it-&gt;second.begin(), it-&gt;second.end() );
<a name="l00276"></a>00276         }
<a name="l00277"></a>00277     };
<a name="l00278"></a>00278 }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
